<?php

namespace Database;

use Model\Athlete;
use Model\Training;
use Model\User;

class EntrainementMapper
{
    public function entrainementSqlToEntity(array $data): array {
        $entrainementEntities = [];

        foreach ($data as $entrainementData) {
            $entrainement = new EntrainementEntity();
            if (isset($entrainementData['idEntrainement'])) {
                $entrainement->setIdEntrainement($entrainementData['idEntrainement']);
            }

            if (isset($entrainementData['date'])) {
                $entrainement->setDate($entrainementData['date']);
            }

            if (isset($entrainementData['description'])) {
                $entrainement->setDescription($entrainementData['description']);
            }

            if (isset($entrainementData['latitude'])) {
                $entrainement->setLatitude($entrainementData['latitude']);
            }

            if (isset($entrainementData['longitude'])) {
                $entrainement->setLongitude($entrainementData['longitude']);
            }

            if (isset($entrainementData['feedback'])) {
                $entrainement->setFeedback($entrainementData['feedback']);
            }

            if (isset($entrainementData['coachId'])) {
                $entrainement->setCoachId($entrainementData['coachId']);
            }

            $entrainementEntities[] = $entrainement;
        }

        return $entrainementEntities;
    }

    public function entrainementEntityToModel(EntrainementEntity $entrainementEntity): Training {
        return new Training(
            $entrainementEntity->getIdEntrainement(),
            $entrainementEntity->getDate(),
            $entrainementEntity->getDescription(),
            $entrainementEntity->getLatitude(),
            $entrainementEntity->getLongitude(),
            $entrainementEntity->getFeedback()
        );
    }

    public function entrainementToEntity(Training $training):EntrainementEntity{

        $train = new EntrainementEntity();
        $train->setIdEntrainement($training->getId());
        $train->setDate($training->getDate());
        $train->setDescription($training->getDescription());
        $train->setLatitude($training->getLatitude());
        $train->setLongitude($training->getLongitude());
        $train->setFeedback($training->getFeedback());
        $train->setCoachId(1);

        return $train;
    }
}